"use strict";
// Programmed by watayan

onload=function(){
	var input_p = document.getElementById("p");
	var input_q = document.getElementById("q");
	var input_e = document.getElementById("e");
	var primes = find_prime(8000,9000);
	var input_array = [input_p, input_q, input_e];
	for(var i = 0; i < primes.length; i++)
	{
		for(var j = 0; j < 3; j++)
		{
			var option = document.createElement('option');
			option.setAttribute('value', primes[i]);
			option.innerHTML = primes[i];
			input_array[j].appendChild(option);
		}
	}
	document.getElementById("make").disabled = true;

}

function all_clear()
{
	var items = ["n","out_e","d",
		"crypt_n","crypt_e","crypt_m","crypt_mn","crypt_cn","crypt_c",
		"decrypt_n","decrypt_d","decrypt_c","decrypt_cn","decrypt_mn","decrypt_m"];
	for(var item of items)
		document.getElementById(item).value = "";
	document.getElementById("p").selectedIndex = 0;
	document.getElementById("q").selectedIndex = 0;
	document.getElementById("e").selectedIndex = 0;
	change_prime();
}

function change_prime()
{
	var input_p = document.getElementById("p");
	var input_q = document.getElementById("q");
	var input_e = document.getElementById("e");
	var p = input_p.value;
	var q = input_q.value;
	var e = input_e.value;
	document.getElementById("make").disabled = (p == q || p == e || q == e);
}

function change_hide()
{
	document.getElementById("p").style.visibility = document.getElementById("hide_p").checked ? "hidden" : "visible";
	document.getElementById("q").style.visibility = document.getElementById("hide_q").checked ? "hidden" : "visible";
	document.getElementById("d").style.visibility = document.getElementById("hide_d").checked ? "hidden" : "visible";
	document.getElementById("decrypt_d").style.visibility = document.getElementById("hide_dd").checked ? "hidden" : "visible";
	document.getElementById("crypt_m").style.visibility =
		document.getElementById("crypt_mn").style.visibility = document.getElementById("hide_m").checked ? "hidden" : "visible";
}

function make_key()
{
	var input_p = document.getElementById("p");
	var input_q = document.getElementById("q");
	var input_e = document.getElementById("e");
	var p = input_p.value;
	var q = input_q.value;
	var e = input_e.value;
	var n = p * q;
	var d = inverse(e, (p-1)*(q-1));
	document.getElementById("n").value = n;
	document.getElementById("out_e").value = e;
	document.getElementById("d").value = d;
//	document.getElementById("decrypt_n").value = n;
//	document.getElementById("decrypt_d").value = d;

// for debug
//	document.getElementById("crypt_n").value = n;
//	document.getElementById("crypt_e").value = e;
//	document.getElementById("decrypt_n").value = n;
//	document.getElementById("decrypt_d").value = d;
}

function crypt()
{
	clear_crypted();
	var n = document.getElementById("crypt_n").value;
	var e = document.getElementById("crypt_e").value;
	var m = document.getElementById("crypt_m").value;
	if(n > 0 && e > 0 && m != "")
	{
		var mn = s2n(m);
		var cn = pow(mn, e, n);
		var c = n2s(cn);
		document.getElementById("crypt_mn").value = mn;
		document.getElementById("crypt_cn").value = cn;
		document.getElementById("crypt_c").value = c;
	}

// for debug
//	document.getElementById("decrypt_c").value = c;
}

function decrypt()
{
	clear_decrypted();
	var n = document.getElementById("decrypt_n").value;
	var d = document.getElementById("decrypt_d").value;
	var c = document.getElementById("decrypt_c").value;
	if(n > 0 && d > 0 && c != "")
	{
		var cn = s2n(c);
		var mn = pow(cn, d, n);
		var m = n2s(mn);
		document.getElementById("decrypt_cn").value = cn;
		document.getElementById("decrypt_mn").value = mn;
		document.getElementById("decrypt_m").value = m;
	}
}

function clear_crypted()
{
	document.getElementById("crypt_mn").value = "";
	document.getElementById("crypt_cn").value = "";
	document.getElementById("crypt_c").value = "";
}

function clear_decrypted()
{
	document.getElementById("decrypt_cn").value = "";
	document.getElementById("decrypt_mn").value = "";
	document.getElementById("decrypt_m").value = "";
}


// a^n % m
function pow(a,n,m)
{
	var p = 1, mask = 1;
	while(mask <= n)
	{
		if(n & mask) p = p * a % m;
		a = a * a % m;
		mask *= 2;
	}
	return p;
}


// [a,b] の範囲の素数の配列
function find_prime(a,b)
{
	var ans = [];
	for(var n = a; n <= b; n++)
		if(is_prime(n)) ans.push(n);
	return ans;
}

function is_prime(n)
{
	if(n % 2 == 0) return false;
	var i = 3;
	while(i * i <= n)
	{
		if(n % i == 0) return false;
		i += 2;
	}
	return true;
}

function gcd(a,b)
{
	if(a % b == 0) return b;
	else return gcd(b, a % b);
}

// ax ≡ 1 (mod n)となるxを返す
// 奥村晴彦「C言語によるアルゴリズム辞典」より
function inverse(a, n)
{
	if(gcd(a,n) > 1) return -1;
	var d, q, r, s, t, x;
	d = n; x = 0; s = 1;
	while(a != 0)
	{
		r = d % a;
		q = (d - r) / a;
		d = a;
		a = r;
		t = x - q * s; x = s; s= t;
	}
	return (x + n) % n;
}

var a2z = "=ABCDEFGHIJKLMNOPQRSTUVWXYZ";

// string sを27進法で数値化する
function s2n(s)
{
	s = s.toUpperCase();
	var n = 0;
	for(var i = 0; i < s.length; i++)
	{
		var c = s.charAt(i);
		var k = a2z.indexOf(c, 0);
		if(k >= 0) n = n * 27 + k;
	}
	return n;
}

// nをstring化する
function n2s(n)
{
	var a = [];
	while(n > 0)
	{
		var m = n % 27;
		a.unshift(a2z.charAt(m));
		n = (n - m) / 27;
	}
	return a.join('');
}

// for debugging with Node.js
// exports.is_prime = is_prime;
// exports.find_prime = find_prime;
// exports.pow = pow;
// exports.gcd = gcd;
// exports.inverse = inverse;
// exports.n2s = n2s;
// exports.s2n = s2n;
